Index: trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java	(revision 10254)
+++ trunk/src/org/openstreetmap/josm/gui/history/HistoryBrowserModel.java	(revision 10308)
@@ -763,11 +763,11 @@
         l.data.addDataSetListener(this);
         OsmPrimitive primitive = history != null ? l.data.getPrimitiveById(history.getId(), history.getType()) : null;
-        HistoryOsmPrimitive latest;
+        HistoryOsmPrimitive newLatest;
         if (canShowAsLatest(primitive)) {
-            latest = new HistoryPrimitiveBuilder().build(primitive);
+            newLatest = new HistoryPrimitiveBuilder().build(primitive);
         } else {
-            latest = null;
-        }
-        setLatest(latest);
+            newLatest = null;
+        }
+        setLatest(newLatest);
         fireModelChange();
     }
Index: trunk/src/org/openstreetmap/josm/gui/history/NodeListTableCellRenderer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/NodeListTableCellRenderer.java	(revision 10254)
+++ trunk/src/org/openstreetmap/josm/gui/history/NodeListTableCellRenderer.java	(revision 10308)
@@ -33,10 +33,9 @@
     protected void renderNode(TwoColumnDiff.Item item, boolean isSelected) {
         String text = "";
-        Color bgColor = Color.WHITE;
         setIcon(nodeIcon);
         if (item.value != null) {
             text = tr("Node {0}", item.value.toString());
         }
-        bgColor = item.state.getColor();
+        Color bgColor = item.state.getColor();
         if (item.state == DiffItemType.EMPTY) {
             text = "";
Index: trunk/src/org/openstreetmap/josm/gui/history/NodeListTableColumnModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/NodeListTableColumnModel.java	(revision 10254)
+++ trunk/src/org/openstreetmap/josm/gui/history/NodeListTableColumnModel.java	(revision 10308)
@@ -7,24 +7,25 @@
 import javax.swing.table.TableColumn;
 
-
 /**
  * The {@link javax.swing.table.TableColumnModel} for the table with the list of nodes.
- *
- *
+ * @since 1709
  */
 public class NodeListTableColumnModel extends DefaultTableColumnModel {
+
+    /**
+     * Constructs a new {@code NodeListTableColumnModel}.
+     */
+    public NodeListTableColumnModel() {
+        createColumns();
+    }
+
     protected void createColumns() {
-        TableColumn col = null;
         NodeListTableCellRenderer renderer = new NodeListTableCellRenderer();
 
         // column 0 - Version
-        col = new TableColumn(0);
+        TableColumn col = new TableColumn(0);
         col.setHeaderValue(tr("Nodes"));
         col.setCellRenderer(renderer);
         addColumn(col);
     }
-
-    public NodeListTableColumnModel() {
-        createColumns();
-    }
 }
Index: trunk/src/org/openstreetmap/josm/gui/history/RelationMemberTableColumnModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/RelationMemberTableColumnModel.java	(revision 10254)
+++ trunk/src/org/openstreetmap/josm/gui/history/RelationMemberTableColumnModel.java	(revision 10308)
@@ -9,13 +9,20 @@
 /**
  * The {@link javax.swing.table.TableColumnModel} for the table with the list of relation members.
- *
+ * @since 1709
  */
 public class RelationMemberTableColumnModel extends DefaultTableColumnModel {
+
+    /**
+     * Constructs a new {@code RelationMemberTableColumnModel}.
+     */
+    public RelationMemberTableColumnModel() {
+        createColumns();
+    }
+
     protected void createColumns() {
-        TableColumn col = null;
         RelationMemberListTableCellRenderer renderer = new RelationMemberListTableCellRenderer();
 
         // column 0 - Version
-        col = new TableColumn(0);
+        TableColumn col = new TableColumn(0);
         col.setHeaderValue(tr("Role"));
         col.setCellRenderer(renderer);
@@ -28,7 +35,3 @@
         addColumn(col);
     }
-
-    public RelationMemberTableColumnModel() {
-        createColumns();
-    }
 }
Index: trunk/src/org/openstreetmap/josm/gui/history/TagTableColumnModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/TagTableColumnModel.java	(revision 10254)
+++ trunk/src/org/openstreetmap/josm/gui/history/TagTableColumnModel.java	(revision 10308)
@@ -12,11 +12,17 @@
  */
 public class TagTableColumnModel extends DefaultTableColumnModel {
+
+    /**
+     * Constructs a new {@code TagTableColumnModel}.
+     */
+    public TagTableColumnModel() {
+        createColumns();
+    }
+
     protected void createColumns() {
-        TableColumn col = null;
-
         TagTableCellRenderer renderer = new TagTableCellRenderer();
 
         // column 0 - Key
-        col = new TableColumn(0);
+        TableColumn col = new TableColumn(0);
         col.setHeaderValue(tr("Key"));
         col.setCellRenderer(renderer);
@@ -28,12 +34,4 @@
         col.setCellRenderer(renderer);
         addColumn(col);
-
-    }
-
-    /**
-     * Constructs a new {@code TagTableColumnModel}.
-     */
-    public TagTableColumnModel() {
-        createColumns();
     }
 }
Index: trunk/src/org/openstreetmap/josm/gui/history/VersionTableColumnModel.java
===================================================================
--- trunk/src/org/openstreetmap/josm/gui/history/VersionTableColumnModel.java	(revision 10254)
+++ trunk/src/org/openstreetmap/josm/gui/history/VersionTableColumnModel.java	(revision 10308)
@@ -11,5 +11,5 @@
 /**
  * The {@link TableColumnModel} for the table with the list of versions
- *
+ * @since 1709
  */
 public class VersionTableColumnModel extends DefaultTableColumnModel {
@@ -26,10 +26,16 @@
     public static final int COL_USER = 4;
 
+    /**
+     * Creates a new {@code VersionTableColumnModel}.
+     */
+    public VersionTableColumnModel() {
+        createColumns();
+    }
+
     protected void createColumns() {
-        TableColumn col = null;
         VersionTable.RadioButtonRenderer bRenderer = new VersionTable.RadioButtonRenderer();
 
         // column 0 - Version
-        col = new TableColumn(COL_VERSION);
+        TableColumn col = new TableColumn(COL_VERSION);
         /* translation note: 3 letter abbr. for "Version" */
         col.setHeaderValue(tr("Ver"));
@@ -62,10 +68,3 @@
         addColumn(col);
     }
-
-    /**
-     * Creates a new {@code VersionTableColumnModel}.
-     */
-    public VersionTableColumnModel() {
-        createColumns();
-    }
 }