Index: trunk/src/org/openstreetmap/josm/io/Capabilities.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/Capabilities.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/Capabilities.java	(revision 10378)
@@ -131,5 +131,5 @@
             }
         } else {
-            if (!capabilities.containsKey(element))  {
+            if (!capabilities.containsKey(element)) {
                 Map<String, String> h = new HashMap<>();
                 capabilities.put(element, h);
Index: trunk/src/org/openstreetmap/josm/io/ChangesetQuery.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/ChangesetQuery.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/ChangesetQuery.java	(revision 10378)
@@ -157,5 +157,5 @@
         CheckParameterUtil.ensureParameterNotNull(min, "min");
         CheckParameterUtil.ensureParameterNotNull(max, "max");
-        this.bounds  = new Bounds(min, max);
+        this.bounds = new Bounds(min, max);
         return this;
     }
@@ -215,5 +215,5 @@
      */
     public ChangesetQuery beingOpen(boolean isOpen) {
-        this.open =  isOpen;
+        this.open = isOpen;
         return this;
     }
@@ -474,5 +474,5 @@
 
         protected Map<String, String> createMapFromQueryString(String query) {
-            Map<String, String> queryParams  = new HashMap<>();
+            Map<String, String> queryParams = new HashMap<>();
             String[] keyValuePairs = query.split("&");
             for (String keyValuePair: keyValuePairs) {
Index: trunk/src/org/openstreetmap/josm/io/DefaultProxySelector.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/DefaultProxySelector.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/DefaultProxySelector.java	(revision 10378)
@@ -97,5 +97,5 @@
             return 0;
         }
-        if (port <= 0 || port >  65535) {
+        if (port <= 0 || port > 65535) {
             Main.error(tr("Illegal port number in preference ''{0}''. Got {1}.", property, port));
             Main.error(tr("The proxy will not be used."));
Index: trunk/src/org/openstreetmap/josm/io/DiffResultProcessor.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/DiffResultProcessor.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/DiffResultProcessor.java	(revision 10378)
@@ -32,5 +32,5 @@
 import org.xml.sax.helpers.DefaultHandler;
 
-public class DiffResultProcessor  {
+public class DiffResultProcessor {
 
     private static class DiffResultEntry {
@@ -76,5 +76,5 @@
      *
      */
-    public  void parse(String diffUploadResponse, ProgressMonitor progressMonitor) throws XmlParsingException {
+    public void parse(String diffUploadResponse, ProgressMonitor progressMonitor) throws XmlParsingException {
         if (progressMonitor == null) {
             progressMonitor = NullProgressMonitor.INSTANCE;
@@ -168,5 +168,5 @@
                 case "way":
                 case "relation":
-                    PrimitiveId id  = new SimplePrimitiveId(
+                    PrimitiveId id = new SimplePrimitiveId(
                             Long.parseLong(atts.getValue("old_id")),
                             OsmPrimitiveType.fromApiTypeName(qName)
Index: trunk/src/org/openstreetmap/josm/io/GpxReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/GpxReader.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/GpxReader.java	(revision 10378)
@@ -504,5 +504,5 @@
 
         @Override
-        public void endDocument() throws SAXException  {
+        public void endDocument() throws SAXException {
             if (!states.empty())
                 throw new SAXException(tr("Parse error: invalid document structure for GPX document."));
Index: trunk/src/org/openstreetmap/josm/io/MultiFetchServerObjectReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/MultiFetchServerObjectReader.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/MultiFetchServerObjectReader.java	(revision 10378)
@@ -314,7 +314,9 @@
         final String baseUrl = getBaseUrl();
         switch (type) {
+            // CHECKSTYLE.OFF: SingleSpaceSeparator
             case NODE:     msg = tr("Fetching a package of nodes from ''{0}''",     baseUrl); break;
             case WAY:      msg = tr("Fetching a package of ways from ''{0}''",      baseUrl); break;
             case RELATION: msg = tr("Fetching a package of relations from ''{0}''", baseUrl); break;
+            // CHECKSTYLE.ON: SingleSpaceSeparator
             default: throw new AssertionError();
         }
@@ -584,7 +586,9 @@
                     String msg;
                     switch (type) {
+                        // CHECKSTYLE.OFF: SingleSpaceSeparator
                         case NODE:     msg = tr("Fetching node with id {0} from ''{1}''",     id, baseUrl); break;
                         case WAY:      msg = tr("Fetching way with id {0} from ''{1}''",      id, baseUrl); break;
                         case RELATION: msg = tr("Fetching relation with id {0} from ''{1}''", id, baseUrl); break;
+                        // CHECKSTYLE.ON: SingleSpaceSeparator
                         default: throw new AssertionError();
                     }
Index: trunk/src/org/openstreetmap/josm/io/NoteReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/NoteReader.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/NoteReader.java	(revision 10378)
@@ -194,5 +194,5 @@
 
         @Override
-        public void endDocument() throws SAXException  {
+        public void endDocument() throws SAXException {
             parsedNotes = notes;
         }
Index: trunk/src/org/openstreetmap/josm/io/OsmApi.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmApi.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/OsmApi.java	(revision 10378)
@@ -133,5 +133,5 @@
      * @throws IllegalArgumentException if serverUrl is null
      */
-    protected OsmApi(String serverUrl)  {
+    protected OsmApi(String serverUrl) {
         CheckParameterUtil.ensureParameterNotNull(serverUrl, "serverUrl");
         this.serverUrl = serverUrl;
Index: trunk/src/org/openstreetmap/josm/io/OsmChangeImporter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmChangeImporter.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/OsmChangeImporter.java	(revision 10378)
@@ -44,5 +44,5 @@
     }
 
-    protected void importData(InputStream in, final File associatedFile, ProgressMonitor  progressMonitor) throws IllegalDataException {
+    protected void importData(InputStream in, final File associatedFile, ProgressMonitor progressMonitor) throws IllegalDataException {
         final DataSet dataSet = OsmChangeReader.parseDataSet(in, progressMonitor);
         final OsmDataLayer layer = new OsmDataLayer(dataSet, associatedFile.getName(), associatedFile);
Index: trunk/src/org/openstreetmap/josm/io/OsmServerBackreferenceReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmServerBackreferenceReader.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/OsmServerBackreferenceReader.java	(revision 10378)
@@ -98,5 +98,5 @@
      * @throws IllegalArgumentException if type is null
      */
-    public OsmServerBackreferenceReader(long id, OsmPrimitiveType type, boolean readFull)  {
+    public OsmServerBackreferenceReader(long id, OsmPrimitiveType type, boolean readFull) {
         this(id, type);
         this.readFull = readFull;
@@ -202,5 +202,5 @@
             }
             if (isReadFull()) {
-                Collection<Relation> relationsToCheck  = new ArrayList<>(ds.getRelations());
+                Collection<Relation> relationsToCheck = new ArrayList<>(ds.getRelations());
                 for (Relation relation: relationsToCheck) {
                     if (!relation.isNew() && relation.hasIncompleteMembers()) {
Index: trunk/src/org/openstreetmap/josm/io/OsmServerReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmServerReader.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/OsmServerReader.java	(revision 10378)
@@ -41,5 +41,5 @@
      * @throws OsmTransferException if data transfer errors occur
      */
-    protected InputStream getInputStream(String urlStr, ProgressMonitor progressMonitor) throws OsmTransferException  {
+    protected InputStream getInputStream(String urlStr, ProgressMonitor progressMonitor) throws OsmTransferException {
         return getInputStream(urlStr, progressMonitor, null);
     }
@@ -55,5 +55,5 @@
      * @throws OsmTransferException if data transfer errors occur
      */
-    protected InputStream getInputStream(String urlStr, ProgressMonitor progressMonitor, String reason) throws OsmTransferException  {
+    protected InputStream getInputStream(String urlStr, ProgressMonitor progressMonitor, String reason) throws OsmTransferException {
         try {
             api.initialize(progressMonitor);
Index: trunk/src/org/openstreetmap/josm/io/auth/AbstractCredentialsAgent.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/auth/AbstractCredentialsAgent.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/auth/AbstractCredentialsAgent.java	(revision 10378)
@@ -20,5 +20,5 @@
         if (requestorType == null)
             return null;
-        PasswordAuthentication credentials =  lookup(requestorType, host);
+        PasswordAuthentication credentials = lookup(requestorType, host);
         final String username = (credentials == null || credentials.getUserName() == null) ? "" : credentials.getUserName();
         final String password = (credentials == null || credentials.getPassword() == null) ? "" : String.valueOf(credentials.getPassword());
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java	(revision 10373)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/AddTagsDialog.java	(revision 10378)
@@ -150,5 +150,5 @@
             ExistingValues old = new ExistingValues(key);
             for (OsmPrimitive osm : sel) {
-                oldValue  = osm.get(key);
+                oldValue = osm.get(key);
                 if (oldValue != null) {
                     old.addValue(oldValue);
@@ -209,5 +209,5 @@
         propertyTable.getInputMap().put(KeyStroke.getKeyStroke(KeyEvent.VK_ENTER, KeyEvent.SHIFT_MASK), "shiftenter");
         propertyTable.getActionMap().put("shiftenter", new AbstractAction() {
-            @Override  public void actionPerformed(ActionEvent e) {
+            @Override public void actionPerformed(ActionEvent e) {
                 buttonAction(1, e); // add all tags on Shift-Enter
             }
@@ -242,5 +242,5 @@
     protected void buttonAction(int buttonIndex, ActionEvent evt) {
         // if layer all layers were closed, ignore all actions
-        if (Main.main.getCurrentDataSet() != null  && buttonIndex != 2) {
+        if (Main.main.getCurrentDataSet() != null && buttonIndex != 2) {
             TableModel tm = propertyTable.getModel();
             for (int i = 0; i < tm.getRowCount(); i++) {