Index: applications/editors/josm/plugins/measurement/build.xml
===================================================================
--- applications/editors/josm/plugins/measurement/build.xml	(revision 10410)
+++ applications/editors/josm/plugins/measurement/build.xml	(revision 10439)
@@ -1,42 +1,67 @@
 <project name="measurement" default="dist" basedir=".">
 
-	<!-- point to your JOSM directory -->
-	<property name="josm" location="../../core/dist/josm-custom.jar" />
+  <!-- josm "user home" directory depends on the platform used (windows has a different place than unix/linux) -->
+  <property environment="env"/>
+  <condition property="josm.home.dir" value="${env.APPDATA}/JOSM" else="${user.home}/.josm">
+    <and>
+      <os family="windows"/>
+    </and>
+  </condition>
 
+  <!-- compilation properties -->
+  <property name="josm.build.dir"   value="../../core"/>
+  <property name="josm.plugins.dir" value="${josm.home.dir}/plugins"/>
+  <property name="josm"             location="../../core/dist/josm-custom.jar" />
+  <property name="plugin.build.dir" value="build"/>
+  <property name="plugin.dist.dir"  value="../../dist"/>
+  <property name="plugin.name"      value="${ant.project.name}"/>
+  <property name="plugin.jar"       value="../../dist/${plugin.name}.jar"/>
 
-	<target name="init">
-		<mkdir dir="build"></mkdir>
-		<mkdir dir="dist"></mkdir>
-	</target>
+  <property name="ant.build.javac.target" value="1.5"/>
 
-	<target name="compile" depends="init">
-		<javac srcdir="src" classpath="${josm}" debug="true" destdir="build" target="1.5">
-			<include name="**/*.java" />
-		</javac>
-	</target>
+  <target name="dist" depends="compile">
+    <!-- images -->
+    <copy todir="build/images">
+      <fileset dir="images" />
+    </copy>
 
-	<target name="dist" depends="compile">
-		<copy todir="build/images" >
-			<fileset dir="images" />
-		</copy>
-		<jar destfile="dist/measurement.jar" basedir="build">
-			<manifest>
-				<attribute name="Plugin-Class" value="org.openstreetmap.josm.plugins.measurement.MeasurementPlugin" />
-				<attribute name="Plugin-Description" value="Provide a measurement dialog and a layer to measure length and angle of segments (there are no segments anymore, I know. Any idea how the angle should be measures now?) and create measurement paths (which also can be imported from a gps layer)" />
-				<attribute name="Plugin-Author" value="mail@raphael-mack.de" />
-				<attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
-				<attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
-			</manifest>
-		</jar>
-	</target>
+    <exec append="false" output="REVISION" executable="svn" failifexecutionfails="false">
+      <env key="LANG" value="C"/>
+      <arg value="info"/>
+      <arg value="--xml"/>
+      <arg value="."/>
+    </exec>
+    <xmlproperty file="REVISION" prefix="version" keepRoot="false" collapseAttributes="true"/>
+    <delete file="REVISION"/>
 
-	<target name="clean">
-		<delete dir="build" />
-		<delete dir="dist" />
-	</target>
+    <jar destfile="${plugin.jar}" basedir="build">
+      <manifest>
+        <attribute name="Plugin-Class" value="org.openstreetmap.josm.plugins.measurement.MeasurementPlugin" />
+        <attribute name="Plugin-Description" value="Provide a measurement dialog and a layer to measure length and angle of segments and create measurement paths (which also can be imported from a gps layer)" />
+        <attribute name="Plugin-Author" value="mail@raphael-mack.de" />
+        <attribute name="Plugin-Version" value="${version.entry.commit.revision}"/>
+        <attribute name="Plugin-Date" value="${version.entry.commit.date}"/>
+      </manifest>
+    </jar>
+  </target>
 
-	<target name="install" depends="dist">
-		<copy file="dist/measurement.jar" todir="${user.home}/.josm/plugins"/>
-	</target>
-	
+  <target name="compile" depends="init">
+    <echo message="creating ${plugin.jar}"/>
+    <javac srcdir="src" classpath="${josm}" destdir="build">
+      <compilerarg value="-Xlint:deprecation"/>
+    </javac>
+  </target>
+
+  <target name="init">
+    <mkdir dir="${plugin.build.dir}" />
+  </target>
+
+  <target name="clean">
+    <delete dir="${plugin.build.dir}" />
+    <delete file="${plugin.jar}" />
+  </target>
+
+  <target name="install" depends="dist">
+    <copy file="${plugin.jar}" todir="${josm.plugins.dir}"/>
+  </target>
 </project>
Index: applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementDialog.java
===================================================================
--- applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementDialog.java	(revision 10410)
+++ applications/editors/josm/plugins/measurement/src/org/openstreetmap/josm/plugins/measurement/MeasurementDialog.java	(revision 10439)
@@ -78,24 +78,24 @@
         JPanel valuePanel = new JPanel(new GridLayout(0,2));
         
-        valuePanel.add(new JLabel("Path Length"));
+        valuePanel.add(new JLabel(tr("Path Length")));
         
         pathLengthLabel = new JLabel("0 m");
         valuePanel.add(pathLengthLabel);
         
-        valuePanel.add(new JLabel("Selection Length"));
+        valuePanel.add(new JLabel(tr("Selection Length")));
         
         selectLengthLabel = new JLabel("0 m");
         valuePanel.add(selectLengthLabel);
 
-        valuePanel.add(new JLabel("Selection Area"));
+        valuePanel.add(new JLabel(tr("Selection Area")));
         
-        selectAreaLabel = new JLabel("0 m²");
+        selectAreaLabel = new JLabel("0 m\uc2b2");
         valuePanel.add(selectAreaLabel);
         
-        JLabel angle = new JLabel("Angle");
+        JLabel angle = new JLabel(tr("Angle"));
         angle.setToolTipText(tr("Angle between two selected Nodes"));
         valuePanel.add(angle);
         
-        segAngleLabel = new JLabel("- °");
+        segAngleLabel = new JLabel("- \uc2b0");
         valuePanel.add(segAngleLabel);
         
@@ -144,6 +144,6 @@
 				dlg.selectLengthLabel.setText(new DecimalFormat("#0.00").format(length) + " m");
 
-				dlg.segAngleLabel.setText(new DecimalFormat("#0.0").format(segAngle) + " °");		
- 				dlg.selectAreaLabel.setText(new DecimalFormat("#0.00").format(area) + " m²");
+				dlg.segAngleLabel.setText(new DecimalFormat("#0.0").format(segAngle) + " \uc2b0");		
+ 				dlg.selectAreaLabel.setText(new DecimalFormat("#0.00").format(area) + " m\uc2b2");
 
 			}