Index: trunk/src/org/openstreetmap/josm/io/BoundingBoxDownloader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/BoundingBoxDownloader.java	(revision 10627)
+++ trunk/src/org/openstreetmap/josm/io/BoundingBoxDownloader.java	(revision 10632)
@@ -203,6 +203,5 @@
 
     @Override
-    public List<Note> parseNotes(int noteLimit, int daysClosed, ProgressMonitor progressMonitor)
-            throws OsmTransferException, MoreNotesException {
+    public List<Note> parseNotes(int noteLimit, int daysClosed, ProgressMonitor progressMonitor) throws OsmTransferException {
         progressMonitor.beginTask(tr("Downloading notes"));
         CheckParameterUtil.ensureThat(noteLimit > 0, "Requested note limit is less than 1.");
Index: trunk/src/org/openstreetmap/josm/io/Capabilities.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/Capabilities.java	(revision 10627)
+++ trunk/src/org/openstreetmap/josm/io/Capabilities.java	(revision 10632)
@@ -98,5 +98,5 @@
      * @throws NumberFormatException if the value is not a valid double
      */
-    public Double getDouble(String element, String attribute) throws NumberFormatException {
+    public Double getDouble(String element, String attribute) {
         String s = get(element, attribute);
         if (s == null) return null;
Index: trunk/src/org/openstreetmap/josm/io/NmeaReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/NmeaReader.java	(revision 10627)
+++ trunk/src/org/openstreetmap/josm/io/NmeaReader.java	(revision 10632)
@@ -447,6 +447,5 @@
     }
 
-    private static LatLon parseLatLon(String ns, String ew, String dlat, String dlon)
-    throws NumberFormatException {
+    private static LatLon parseLatLon(String ns, String ew, String dlat, String dlon) {
         String widthNorth = dlat.trim();
         String lengthEast = dlon.trim();
Index: trunk/src/org/openstreetmap/josm/io/OsmExporter.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/OsmExporter.java	(revision 10627)
+++ trunk/src/org/openstreetmap/josm/io/OsmExporter.java	(revision 10632)
@@ -5,5 +5,4 @@
 
 import java.io.File;
-import java.io.FileNotFoundException;
 import java.io.IOException;
 import java.io.OutputStream;
@@ -76,5 +75,5 @@
     }
 
-    protected static OutputStream getOutputStream(File file) throws FileNotFoundException, IOException {
+    protected static OutputStream getOutputStream(File file) throws IOException {
         return Compression.getCompressedFileOutputStream(file);
     }
@@ -125,5 +124,5 @@
     }
 
-    protected void doSave(File file, OsmDataLayer layer) throws IOException, FileNotFoundException {
+    protected void doSave(File file, OsmDataLayer layer) throws IOException {
         // create outputstream and wrap it with gzip or bzip, if necessary
         try (
Index: trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpsServer.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpsServer.java	(revision 10627)
+++ trunk/src/org/openstreetmap/josm/io/remotecontrol/RemoteControlHttpsServer.java	(revision 10632)
@@ -363,9 +363,8 @@
      * @param ipv6 Whether IPv6 or IPv4 server should be started
      * @throws IOException when connection errors
-     * @throws NoSuchAlgorithmException if the JVM does not support TLS (can not happen)
      * @throws GeneralSecurityException in case of SSL setup errors
      * @since 8339
      */
-    public RemoteControlHttpsServer(int port, boolean ipv6) throws IOException, NoSuchAlgorithmException, GeneralSecurityException {
+    public RemoteControlHttpsServer(int port, boolean ipv6) throws IOException, GeneralSecurityException {
         super("RemoteControl HTTPS Server");
         this.setDaemon(true);
Index: trunk/src/org/openstreetmap/josm/io/session/SessionReader.java
===================================================================
--- trunk/src/org/openstreetmap/josm/io/session/SessionReader.java	(revision 10627)
+++ trunk/src/org/openstreetmap/josm/io/session/SessionReader.java	(revision 10632)
@@ -606,5 +606,5 @@
     }
 
-    private static InputStream getZipInputStream(ZipFile zipFile) throws ZipException, IOException, IllegalDataException {
+    private static InputStream getZipInputStream(ZipFile zipFile) throws IOException, IllegalDataException {
         ZipEntry josEntry = null;
         Enumeration<? extends ZipEntry> entries = zipFile.entries();