Index: trunk/images/presets/misc/information/map.svg
===================================================================
--- trunk/images/presets/misc/information/map.svg	(revision 10707)
+++ trunk/images/presets/misc/information/map.svg	(revision 10707)
@@ -0,0 +1,123 @@
+<?xml version="1.0" encoding="UTF-8" standalone="no"?>
+<!-- Creator: CorelDRAW -->
+
+<svg
+   xmlns:dc="http://purl.org/dc/elements/1.1/"
+   xmlns:cc="http://creativecommons.org/ns#"
+   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
+   xmlns:svg="http://www.w3.org/2000/svg"
+   xmlns="http://www.w3.org/2000/svg"
+   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
+   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
+   xml:space="preserve"
+   width="16"
+   height="16"
+   style="clip-rule:evenodd;fill-rule:evenodd;image-rendering:optimizeQuality;shape-rendering:geometricPrecision;text-rendering:geometricPrecision"
+   viewBox="0 0 4.5155555 4.5155555"
+   version="1.0"
+   sodipodi:version="0.32"
+   inkscape:version="0.91 r13725"
+   sodipodi:docname="map3.svg"
+   id="svg2"><metadata
+   id="metadata18"><rdf:RDF><cc:Work
+       rdf:about=""><dc:format>image/svg+xml</dc:format><dc:type
+         rdf:resource="http://purl.org/dc/dcmitype/StillImage" /><dc:title></dc:title></cc:Work></rdf:RDF></metadata><sodipodi:namedview
+   pagecolor="#ffffff"
+   bordercolor="#666666"
+   borderopacity="1"
+   objecttolerance="10"
+   gridtolerance="10"
+   guidetolerance="10"
+   inkscape:pageopacity="0"
+   inkscape:pageshadow="2"
+   inkscape:window-width="1680"
+   inkscape:window-height="988"
+   id="namedview16"
+   showgrid="false"
+   units="px"
+   fit-margin-top="0"
+   fit-margin-left="0"
+   fit-margin-right="0"
+   fit-margin-bottom="0"
+   inkscape:zoom="3.3302222"
+   inkscape:cx="7.9999988"
+   inkscape:cy="7.6997182"
+   inkscape:window-x="-8"
+   inkscape:window-y="-8"
+   inkscape:window-maximized="1"
+   inkscape:current-layer="svg2" />
+ <defs
+   id="defs4">
+  <style
+   type="text/css"
+   id="style6">
+   <![CDATA[
+    .str2 {stroke:#84C225;stroke-width:0.0762}
+    .str0 {stroke:#84C225;stroke-width:0.2}
+    .str1 {stroke:white;stroke-width:0.2}
+    .fil0 {fill:#84C225}
+    .fil1 {fill:white}
+    .fil2 {fill:#84C225;fill-rule:nonzero}
+   ]]>
+  </style>
+ </defs>
+ <g
+   id="Ebene_x0020_1"
+   transform="matrix(0.22354235,0,0,0.22354235,0.02235424,0.02235424)">
+  <metadata
+   id="CorelCorpID_0Corel-Layer" />
+  <path
+   class="fil0 str0"
+   d="M 2.6772,0 17.3228,0 C 18.8011,0 20,1.7983 20,4.0158 l 0,11.9684 c 0,2.2174 -1.1989,4.0157 -2.6772,4.0157 L 2.6772,20 C 1.1989,19.9999 1e-4,18.2016 1e-4,15.9841 L 0,4.0158 C 1e-4,1.7983 1.1989,0 2.6773,0 Z"
+   id="path10"
+   inkscape:connector-curvature="0"
+   style="fill:#84c225;stroke:#84c225;stroke-width:0.2" />
+  <circle
+   class="fil1 str1"
+   cx="10"
+   cy="10"
+   r="6"
+   id="circle12"
+   style="fill:#ffffff;stroke:#ffffff;stroke-width:0.2" />
+  <path
+   id="_1"
+   class="fil2 str2"
+   d="M 9.9989,7.3298 C 9.6687,7.3298 9.3978,7.2324 9.1882,7.0356 8.9766,6.8387 8.8707,6.5995 8.8707,6.3138 8.8707,6.0196 8.9766,5.7804 9.1882,5.5941 9.3978,5.4078 9.6687,5.3147 9.9989,5.3147 c 0.3366,0 0.6075,0.0931 0.817,0.2794 0.2075,0.1863 0.3133,0.4255 0.3133,0.7197 0,0.2984 -0.1058,0.5418 -0.3133,0.7323 -0.2095,0.1884 -0.4804,0.2837 -0.817,0.2837 z m 0.9673,7.3554 -1.9579,0 0,-6.35 1.9579,0 0,6.35 z"
+   inkscape:connector-curvature="0"
+   style="fill:#84c225;fill-rule:nonzero;stroke:#84c225;stroke-width:0.0762" />
+  <sodipodi:namedview
+   inkscape:window-height="749"
+   inkscape:window-width="1024"
+   inkscape:pageshadow="2"
+   inkscape:pageopacity="1"
+   guidetolerance="10.0"
+   gridtolerance="10.0"
+   objecttolerance="10.0"
+   borderopacity="1.0"
+   bordercolor="#666666"
+   pagecolor="white"
+   id="base"
+   inkscape:zoom="1.05"
+   inkscape:cx="426.38288"
+   inkscape:cy="175.14"
+   inkscape:window-x="545"
+   inkscape:window-y="8"
+   inkscape:current-layer="g2015"
+   inkscape:showpageshadow="false"
+   showborder="true"
+   showgrid="true"
+   width="440px"
+   height="360px"><inkscape:grid
+     id="GridFromPre046Settings"
+     type="xygrid"
+     originx="0px"
+     originy="0px"
+     spacingx="1px"
+     spacingy="1px"
+     color="#3f3fff"
+     empcolor="#3f3fff"
+     opacity="0.15"
+     empopacity="0.38"
+     empspacing="20" /></sodipodi:namedview>
+ </g>
+</svg>
Index: trunk/images/presets/misc/information/map3.svg
===================================================================
--- trunk/images/presets/misc/information/map3.svg	(revision 10706)
+++ 	(revision )
@@ -1,123 +1,0 @@
-<?xml version="1.0" encoding="UTF-8" standalone="no"?>
-<!-- Creator: CorelDRAW -->
-
-<svg
-   xmlns:dc="http://purl.org/dc/elements/1.1/"
-   xmlns:cc="http://creativecommons.org/ns#"
-   xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#"
-   xmlns:svg="http://www.w3.org/2000/svg"
-   xmlns="http://www.w3.org/2000/svg"
-   xmlns:sodipodi="http://sodipodi.sourceforge.net/DTD/sodipodi-0.dtd"
-   xmlns:inkscape="http://www.inkscape.org/namespaces/inkscape"
-   xml:space="preserve"
-   width="16"
-   height="16"
-   style="clip-rule:evenodd;fill-rule:evenodd;image-rendering:optimizeQuality;shape-rendering:geometricPrecision;text-rendering:geometricPrecision"
-   viewBox="0 0 4.5155555 4.5155555"
-   version="1.0"
-   sodipodi:version="0.32"
-   inkscape:version="0.91 r13725"
-   sodipodi:docname="map3.svg"
-   id="svg2"><metadata
-   id="metadata18"><rdf:RDF><cc:Work
-       rdf:about=""><dc:format>image/svg+xml</dc:format><dc:type
-         rdf:resource="http://purl.org/dc/dcmitype/StillImage" /><dc:title></dc:title></cc:Work></rdf:RDF></metadata><sodipodi:namedview
-   pagecolor="#ffffff"
-   bordercolor="#666666"
-   borderopacity="1"
-   objecttolerance="10"
-   gridtolerance="10"
-   guidetolerance="10"
-   inkscape:pageopacity="0"
-   inkscape:pageshadow="2"
-   inkscape:window-width="1680"
-   inkscape:window-height="988"
-   id="namedview16"
-   showgrid="false"
-   units="px"
-   fit-margin-top="0"
-   fit-margin-left="0"
-   fit-margin-right="0"
-   fit-margin-bottom="0"
-   inkscape:zoom="3.3302222"
-   inkscape:cx="7.9999988"
-   inkscape:cy="7.6997182"
-   inkscape:window-x="-8"
-   inkscape:window-y="-8"
-   inkscape:window-maximized="1"
-   inkscape:current-layer="svg2" />
- <defs
-   id="defs4">
-  <style
-   type="text/css"
-   id="style6">
-   <![CDATA[
-    .str2 {stroke:#84C225;stroke-width:0.0762}
-    .str0 {stroke:#84C225;stroke-width:0.2}
-    .str1 {stroke:white;stroke-width:0.2}
-    .fil0 {fill:#84C225}
-    .fil1 {fill:white}
-    .fil2 {fill:#84C225;fill-rule:nonzero}
-   ]]>
-  </style>
- </defs>
- <g
-   id="Ebene_x0020_1"
-   transform="matrix(0.22354235,0,0,0.22354235,0.02235424,0.02235424)">
-  <metadata
-   id="CorelCorpID_0Corel-Layer" />
-  <path
-   class="fil0 str0"
-   d="M 2.6772,0 17.3228,0 C 18.8011,0 20,1.7983 20,4.0158 l 0,11.9684 c 0,2.2174 -1.1989,4.0157 -2.6772,4.0157 L 2.6772,20 C 1.1989,19.9999 1e-4,18.2016 1e-4,15.9841 L 0,4.0158 C 1e-4,1.7983 1.1989,0 2.6773,0 Z"
-   id="path10"
-   inkscape:connector-curvature="0"
-   style="fill:#84c225;stroke:#84c225;stroke-width:0.2" />
-  <circle
-   class="fil1 str1"
-   cx="10"
-   cy="10"
-   r="6"
-   id="circle12"
-   style="fill:#ffffff;stroke:#ffffff;stroke-width:0.2" />
-  <path
-   id="_1"
-   class="fil2 str2"
-   d="M 9.9989,7.3298 C 9.6687,7.3298 9.3978,7.2324 9.1882,7.0356 8.9766,6.8387 8.8707,6.5995 8.8707,6.3138 8.8707,6.0196 8.9766,5.7804 9.1882,5.5941 9.3978,5.4078 9.6687,5.3147 9.9989,5.3147 c 0.3366,0 0.6075,0.0931 0.817,0.2794 0.2075,0.1863 0.3133,0.4255 0.3133,0.7197 0,0.2984 -0.1058,0.5418 -0.3133,0.7323 -0.2095,0.1884 -0.4804,0.2837 -0.817,0.2837 z m 0.9673,7.3554 -1.9579,0 0,-6.35 1.9579,0 0,6.35 z"
-   inkscape:connector-curvature="0"
-   style="fill:#84c225;fill-rule:nonzero;stroke:#84c225;stroke-width:0.0762" />
-  <sodipodi:namedview
-   inkscape:window-height="749"
-   inkscape:window-width="1024"
-   inkscape:pageshadow="2"
-   inkscape:pageopacity="1"
-   guidetolerance="10.0"
-   gridtolerance="10.0"
-   objecttolerance="10.0"
-   borderopacity="1.0"
-   bordercolor="#666666"
-   pagecolor="white"
-   id="base"
-   inkscape:zoom="1.05"
-   inkscape:cx="426.38288"
-   inkscape:cy="175.14"
-   inkscape:window-x="545"
-   inkscape:window-y="8"
-   inkscape:current-layer="g2015"
-   inkscape:showpageshadow="false"
-   showborder="true"
-   showgrid="true"
-   width="440px"
-   height="360px"><inkscape:grid
-     id="GridFromPre046Settings"
-     type="xygrid"
-     originx="0px"
-     originy="0px"
-     spacingx="1px"
-     spacingy="1px"
-     color="#3f3fff"
-     empcolor="#3f3fff"
-     opacity="0.15"
-     empopacity="0.38"
-     empspacing="20" /></sodipodi:namedview>
- </g>
-</svg>